#include <iostream>
#include <vector>

using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data() {
    size_t number_count;
    cerr << "Enter number count: ";
    cin >> number_count;
    Input in;
    in.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++)
    {
        cin >> in.numbers[i];
    }
    cerr << "Enter bin count: ";
    cin >> in.bin_count;
    return in;
}

void
find_minmax(const vector<double>& numbers, double& min, double& max) {
    min = numbers[0];
    max = numbers[0];
    for (double x : numbers) {
        if (x > max )
        {
            max = x;
        }
        if (x < min)
        {
            min = x;
        }
    }
}

int main()
{
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
    Input in = input_data();
    vector<size_t> bins(in.bin_count);
    double min = 0;
    double max = 0;
    find_minmax(in.numbers, min, max);
    auto bin_size = (max - min)/in.bin_count;
    for (double number : in.numbers)
    {
        bool found = false;
        for (size_t j = 0; (j < in.bin_count - 1) && !found; j++)
        {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= number) && (number < hi))
            {
                bins[j]++;
                found = true;
            }
        }
        if (!found)
        {
            bins[in.bin_count - 1]++;
        }
    }
    size_t max_count = 0;
    for (size_t s = 0; s < in.bin_count; s++) {
        if (bins[s] > max_count)
            {
                max_count = bins[s];
            }
    }
    for (size_t bin : bins)
    {
        if (bin <100)
        {
            cout << " ";
        }
        if (bin <10)
        {
            cout << " ";
        }
        cout << bin << "|";
        if (max_count > MAX_ASTERISK) {
            size_t count = bin;
            size_t height = MAX_ASTERISK * (static_cast<double>(count) / max_count);
            for (size_t t = 0; t < height; t++)
            {
                cout << "*";
            }
        }
        else for (size_t k = 0; k < bin; k++)
            {
                cout << "*";
            }
        cout << endl;
    }
}
